/*
*  Naamari - an AES/SHA-based manual file crypto-synchronizer for cloud transfers
*  Copyright (c) 2015-2017 Sunkware
*  Key FP = 6B6D C8E9 3438 6E9C 3D97  56E5 2CE9 A476 99EF 28F6
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*  See the GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*  ----------------------------------------------------------------
*  WWW:       sunkware.org
*  E-mail:    sunkware@gmail.com
*  ----------------------------------------------------------------
*/

#include "md.h"


using namespace cryptrav;


namespace commander
{


int            md(ContextGlob* pContext, StateGlob* pState, QStringList argList)
{
 if ( (pContext == NULL) || (pState == NULL) )
  return COMERR_NULL_POINTER;


 QStringList comList;
 QStringList optList;
 CommandLineParser::separate(&argList, &comList, &optList);


 if ( optList.contains("--help") )
  {
   Console::putHelp("Available 'md' subcommands:");
   Console::putHelp("  hallway <dirname>  (alias: 'mdh <dirname>')");
   Console::putHelp("  nominis <dirname>  (alias: 'mdn <dirname>')");
   Console::putHelp("Available 'md' options:");
   Console::putHelp("  --help");

   return COMERR_OK;
  }


 QString       paramact = "";
 QString       dirname = "";

 Pather        pather(pContext);


 if (comList.count() < 1)
  {
   Console::putFailure("No subcommand (try 'md --help')");
   return COMERR_NO_SUBCOMMAND;
  }

 paramact = comList.at(0);


 if (comList.count() < 2)
  {
   Console::putFailure("No dir name (try 'md --help')");
   return COMERR_EMPTY_OBJECT_NAME;
  }

 dirname = comList.at(1);


 if (dirname.contains("/"))
  {
   Console::putFailure("Path not allowed here");
   return COMERR_PATH_NOT_ALLOWED;
  }


 if (paramact == "hallway")
  {
   if ( QDir(pather.getHallwayAbs(pState -> getPathInHallway() + "/" + dirname)).exists() )
    {
     Console::putFailure("Already exists");
     return COMERR_DIR_ALREADY_EXISTS;
    }

   Console::putOutcome( QDir(pather.getHallwayAbs(pState -> getPathInHallway())).mkdir(dirname) );
  }
 else if (paramact == "nominis")
  {
   if ( QDir(pather.getNominisAbs(pState -> getPathInNominis() + "/" + dirname)).exists() )
    {
     Console::putFailure("Already exists");
     return COMERR_DIR_ALREADY_EXISTS;
    }

   Console::putOutcome( QDir(pather.getNominisAbs(pState -> getPathInNominis())).mkdir(dirname) );
  }
 else
  {
   Console::putFailure("Unknown subcommand (try 'md --help')");
   return COMERR_UNKNOWN_SUBCOMMAND;
  }


 return COMERR_OK;
}


} // namespace "commander"
